<html>
<head>
<title>OgreShaderExHardwareSkinning.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderExHardwareSkinning.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderExHardwareSkinning_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderExHardwareSkinning_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderExHardwareSkinning_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_EXT_SHADERS</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystem_8h.html">OgreRenderSystem.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderFunctionAtom_8h.html">OgreShaderFunctionAtom.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderExLinearSkinning_8h.html">OgreShaderExLinearSkinning.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderExHardwareSkinningTechnique_8h.html">OgreShaderExHardwareSkinningTechnique.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderExDualQuaternionSkinning_8h.html">OgreShaderExDualQuaternionSkinning.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderExLinearSkinning_8h.html">OgreShaderExLinearSkinning.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#define HS_MAX_WEIGHT_COUNT 4</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="keyword">namespace </span>Ogre {
<a name="l00045"></a>00045 <span class="keyword">namespace </span>RTShader {
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="keyword">class </span>HardwareSkinningFactory;
<a name="l00049"></a>00049 
<a name="l00061"></a>00061 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> HardwareSkinning : <span class="keyword">public</span> SubRenderState
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 <span class="keyword">public</span>:
<a name="l00064"></a>00064     <span class="keyword">struct </span>SkinningData
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066         SkinningData() :
<a name="l00067"></a>00067             isValid(true), maxBoneCount(0), maxWeightCount(0), skinningType(<a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1ab979c94e41c61d62d15f4771c5202e3c">ST_LINEAR</a>), correctAntipodalityHandling(false), scalingShearingSupport(false)
<a name="l00068"></a>00068         {}
<a name="l00069"></a>00069 
<a name="l00070"></a>00070         <span class="keywordtype">bool</span> isValid;
<a name="l00071"></a>00071         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> maxBoneCount;
<a name="l00072"></a>00072         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> maxWeightCount;
<a name="l00073"></a>00073         <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType;
<a name="l00074"></a>00074         <span class="keywordtype">bool</span> correctAntipodalityHandling;
<a name="l00075"></a>00075         <span class="keywordtype">bool</span> scalingShearingSupport;
<a name="l00076"></a>00076     };
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="comment">// Interface.</span>
<a name="l00079"></a>00079 <span class="keyword">public</span>:
<a name="l00081"></a>00081     HardwareSkinning();
<a name="l00082"></a>00082 
<a name="l00086"></a>00086     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType() <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00091"></a>00091     <span class="keyword">virtual</span> <span class="keywordtype">int</span> getExecutionOrder() <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096     <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyFrom(<span class="keyword">const</span> SubRenderState&amp; rhs);
<a name="l00097"></a>00097 
<a name="l00110"></a>00110     <span class="keywordtype">void</span> setHardwareSkinningParam(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> boneCount, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> weightCount, <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType = <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1ab979c94e41c61d62d15f4771c5202e3c">ST_LINEAR</a>,  <span class="keywordtype">bool</span> correctAntipodalityHandling = <span class="keyword">false</span>, <span class="keywordtype">bool</span> scalingShearingSupport = <span class="keyword">false</span>);
<a name="l00111"></a>00111 
<a name="l00116"></a>00116     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getBoneCount();
<a name="l00117"></a>00117 
<a name="l00122"></a>00122     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getWeightCount();
<a name="l00123"></a>00123 
<a name="l00128"></a>00128     <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> getSkinningType();
<a name="l00129"></a>00129 
<a name="l00134"></a>00134     <span class="keywordtype">bool</span> hasCorrectAntipodalityHandling();
<a name="l00135"></a>00135 
<a name="l00140"></a>00140     <span class="keywordtype">bool</span> hasScalingShearingSupport();
<a name="l00141"></a>00141 
<a name="l00145"></a>00145     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> preAddToRenderState(<span class="keyword">const</span> RenderState* renderState, Pass* srcPass, Pass* dstPass);
<a name="l00146"></a>00146 
<a name="l00150"></a>00150     <span class="keywordtype">void</span> _setCreator(<span class="keyword">const</span> HardwareSkinningFactory* pCreator) { mCreator = pCreator; }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Type;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">// Protected methods</span>
<a name="l00155"></a>00155 <span class="keyword">protected</span>:
<a name="l00159"></a>00159     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> resolveParameters (ProgramSet* programSet);
<a name="l00160"></a>00160 
<a name="l00164"></a>00164     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> resolveDependencies (ProgramSet* programSet);
<a name="l00165"></a>00165 
<a name="l00169"></a>00169     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> addFunctionInvocations (ProgramSet* programSet);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     SharedPtr&lt;LinearSkinning&gt; mLinear;
<a name="l00172"></a>00172     SharedPtr&lt;DualQuaternionSkinning&gt; mDualQuat;
<a name="l00173"></a>00173     SharedPtr&lt;HardwareSkinningTechnique&gt; mActiveTechnique;
<a name="l00174"></a>00174     
<a name="l00175"></a>00175     <span class="keyword">const</span> HardwareSkinningFactory* mCreator; 
<a name="l00176"></a>00176     <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> mSkinningType;
<a name="l00177"></a>00177 };
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <span class="keywordtype">void</span> <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> HardwareSkinning::SkinningData&amp; data);
<a name="l00180"></a>00180 
<a name="l00185"></a>00185 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> HardwareSkinningFactory : <span class="keyword">public</span> SubRenderStateFactory, 
<a name="l00186"></a>00186     <span class="keyword">public</span> Singleton&lt;HardwareSkinningFactory&gt;
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188 <span class="keyword">public</span>:
<a name="l00189"></a>00189     HardwareSkinningFactory();
<a name="l00190"></a>00190     
<a name="l00194"></a>00194     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType() <span class="keyword">const</span>;
<a name="l00195"></a>00195 
<a name="l00199"></a>00199     <span class="keyword">virtual</span> SubRenderState* createInstance(ScriptCompiler* compiler, PropertyAbstractNode* prop, Pass* pass, SGScriptTranslator* translator);
<a name="l00200"></a>00200 
<a name="l00204"></a>00204     <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeInstance(MaterialSerializer* ser, SubRenderState* subRenderState, Pass* srcPass, Pass* dstPass);
<a name="l00205"></a>00205 
<a name="l00209"></a>00209     <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCustomShadowCasterMaterials(<span class="keyword">const</span> <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType, <span class="keyword">const</span> MaterialPtr&amp; caster1Weight, <span class="keyword">const</span> MaterialPtr&amp; caster2Weight,
<a name="l00210"></a>00210         <span class="keyword">const</span> MaterialPtr&amp; caster3Weight, <span class="keyword">const</span> MaterialPtr&amp; caster4Weight);
<a name="l00211"></a>00211     
<a name="l00215"></a>00215     <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCustomShadowReceiverMaterials(<span class="keyword">const</span> <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType, <span class="keyword">const</span> MaterialPtr&amp; receiver1Weight, <span class="keyword">const</span> MaterialPtr&amp; receiver2Weight,
<a name="l00216"></a>00216         <span class="keyword">const</span> MaterialPtr&amp; receiver3Weight, <span class="keyword">const</span> MaterialPtr&amp; receiver4Weight);
<a name="l00217"></a>00217 
<a name="l00221"></a>00221     <span class="keyword">const</span> MaterialPtr&amp; getCustomShadowCasterMaterial(<span class="keyword">const</span> <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index) <span class="keyword">const</span>;
<a name="l00222"></a>00222 
<a name="l00226"></a>00226     <span class="keyword">const</span> MaterialPtr&amp; getCustomShadowReceiverMaterial(<span class="keyword">const</span> <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> index) <span class="keyword">const</span>;
<a name="l00227"></a>00227 
<a name="l00243"></a>00243     <span class="keywordtype">void</span> prepareEntityForSkinning(<span class="keyword">const</span> Entity* pEntity, <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType = <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1ab979c94e41c61d62d15f4771c5202e3c">ST_LINEAR</a>, <span class="keywordtype">bool</span> correctAntidpodalityHandling = <span class="keyword">false</span>, <span class="keywordtype">bool</span> shearScale = <span class="keyword">false</span>);
<a name="l00244"></a>00244 
<a name="l00255"></a>00255     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getMaxCalculableBoneCount()<span class="keyword"> const </span>{
<a name="l00256"></a>00256         <span class="keywordflow">return</span> mMaxCalculableBoneCount; }
<a name="l00261"></a>00261     <span class="keywordtype">void</span> setMaxCalculableBoneCount(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> count) {
<a name="l00262"></a>00262         mMaxCalculableBoneCount = count; }
<a name="l00263"></a>00263 
<a name="l00281"></a>00281     <span class="keyword">static</span> HardwareSkinningFactory&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00282"></a>00282     
<a name="l00300"></a>00300     <span class="keyword">static</span> HardwareSkinningFactory* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 <span class="keyword">protected</span>:
<a name="l00312"></a>00312     <span class="keywordtype">bool</span> extractSkeletonData(<span class="keyword">const</span> Entity* pEntity, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&amp; boneCount,
<a name="l00313"></a>00313         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&amp; weightCount);
<a name="l00314"></a>00314 
<a name="l00325"></a>00325     <span class="keywordtype">bool</span> imprintSkeletonData(<span class="keyword">const</span> MaterialPtr&amp; pMaterial, <span class="keywordtype">bool</span> isVaild, 
<a name="l00326"></a>00326         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> boneCount, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> weightCount, <a class="code" href="namespaceOgre_1_1RTShader.html#a8c100ce939d23573f062f3ad579998a1">SkinningType</a> skinningType, <span class="keywordtype">bool</span> correctAntidpodalityHandling, <span class="keywordtype">bool</span> scalingShearingSupport);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="keyword">protected</span>:
<a name="l00329"></a>00329 
<a name="l00333"></a>00333     <span class="keyword">virtual</span> SubRenderState* createInstanceImpl();
<a name="l00334"></a>00334 
<a name="l00336"></a>00336     MaterialPtr mCustomShadowCasterMaterialsLinear[HS_MAX_WEIGHT_COUNT];
<a name="l00337"></a>00337     MaterialPtr mCustomShadowCasterMaterialsDualQuaternion[HS_MAX_WEIGHT_COUNT];
<a name="l00338"></a>00338 
<a name="l00340"></a>00340     MaterialPtr mCustomShadowReceiverMaterialsLinear[HS_MAX_WEIGHT_COUNT];
<a name="l00341"></a>00341     MaterialPtr mCustomShadowReceiverMaterialsDualQuaternion[HS_MAX_WEIGHT_COUNT];
<a name="l00342"></a>00342 
<a name="l00345"></a>00345     <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> mMaxCalculableBoneCount;
<a name="l00346"></a>00346 };
<a name="l00347"></a>00347 
<a name="l00352"></a>00352 }
<a name="l00353"></a>00353 }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 <span class="preprocessor">#endif</span>
<a name="l00356"></a>00356 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00357"></a>00357 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
